var gulp = require('gulp');
var replace = require('gulp-replace');
var path = require('path');

const STAGING_DL_URL = 'http://dl.freshcloud.io';
const PRODUCTION_DL_URL = 'http://dl.freshdev.io';

const STAGING_WS_URL = 'http://ws.freshcloud.io';
const PRODUCTION_WS_URL = 'http://ws.freshdev.io';

const STAGING_STATIC_URL = 'http://static.freshcloud.io';
const PRODUCTION_STATIC_URL = 'http://static.freshdev.io';

var FILES = [
  './lib/web/pages/event-page.html',
  './lib/web/pages/event-page-404.html',
  './lib/web/pages/oauth-forms.html',
  './lib/web/pages/custom-iparams.html',
  './lib/web/assets/js/event-page.js',
  './lib/cli/version.js'
]

gulp.task('staging', function() {
  FILES.map(function (file) {
    gulp.src(file)
      .pipe(replace(PRODUCTION_DL_URL, STAGING_DL_URL))
      .pipe(replace(PRODUCTION_WS_URL, STAGING_WS_URL))
      .pipe(gulp.dest(path.parse(file).dir));
  });
});

gulp.task('production', function() {
  FILES.map(function (file) {
    gulp.src(file)
      .pipe(replace(STAGING_DL_URL, PRODUCTION_DL_URL))
      .pipe(replace(STAGING_WS_URL, PRODUCTION_WS_URL))
      .pipe(replace(STAGING_STATIC_URL, PRODUCTION_STATIC_URL))
      .pipe(gulp.dest(path.parse(file).dir));
  });
});
