'use strict';

const debuglog = __debug.bind(null, __filename);

var eventHandler = require('../event_handler/framework');
var configUtil = require('../utils/config-util');
var _ = require('underscore');
const CATEGORY_NAME = 'request';

function iParamConfigs() {
  return configUtil.getValuesForLocalTesting();
}

module.exports = {
  invoke: function(req, res) {
    var options = {
      categoryName: CATEGORY_NAME,
      categoryArgs: {
        methodName: req.body.methodName,
        methodParams: _.extend(req.body.methodParams, {iparams: iParamConfigs()})
      }
    }
    req.body = options;
    req.timeout = 5000;
    eventHandler(req, res);
  }
}