'use strict';

var MESSAGES = {
  "create"  : [ "Usage: fdk create [--app-dir DIR] [--products PRODUCT] [--template TEMPLATE]\n",
                "Options:\n--app-dir DIR where DIR is the path to the directory where the app will be created. If this option is not specified, the app will be created in the current directory.\n--products PRODUCT where PRODUCT is a Freshworks product. If this option is not specified, the product is assumed to be Freshdesk.\n--template TEMPLATE where TEMPLATE is the name of one of the templates that can be used as a starting point for development. If this option is not specified, a prompt is displayed with the list of supported templates for the given product.\n",
                "Creates a new app. The directories and files created will vary depending on the chosen template."],
  "run"     : [ "Usage: fdk run [--app-dir DIR]\n",
                "Options:\n--app-dir DIR where DIR is the path to the directory that contains the manifest file. If this option is not specified, the current directory is assumed to contain the manifest file.\n--clear-coverage Reset coverage data collected so far.\n--skip-coverage Skip instrumenting code during the current run.\n",
                "Runs the app on a local server for testing.",
                "Once the server has started, append `dev=true` to your Freshdesk support URL to start testing",
                "e.g. https://domain.freshdesk.com/helpdesk/tickets/1?dev=true"],
  "validate": [ "Usage: fdk validate [--app-dir DIR]\n",
                "Options:\n--app-dir DIR where DIR is the path to the directory that contains the manifest file. If this option is not specified, the current directory is assumed to contain the manifest file.\n",
                "Runs validation suite on the app"],
  "pack"    : [ "Usage: fdk pack [--app-dir DIR]\n",
                "Options:\n--app-dir DIR where DIR is the path to the directory that contains the manifest file. If this option is not specified, the current directory is assumed to contain the manifest file.\n",
                "Packs the app into a zip file after running a validation suite. You can upload this file to the marketplace by following the instructions at https://developer.freshdesk.com/v2/docs/freshdesk-apps/"],
  "version" : [ "Usage: fdk version\n",
                "Displays the installed and latest version of the Freshworks CLI tool"]

}

var printHelp = function(command) {
  console.log(MESSAGES[command].join("\n"));
}

module.exports = {
  printHelp: printHelp
}
