'use strict';

module.exports = {
  capitalize: function(word) {
    return word.charAt(0).toUpperCase() + word.slice(1);
  },
  objsize: function(obj) {
    var bytes = 0;

    if(obj !== null && obj !== undefined) {
        switch(typeof obj) {
        case 'number':
            bytes += 8;
            break;
        case 'string':
            bytes += obj.length;
            break;
        case 'boolean':
            bytes += 1;
            break;
        case 'object':
            var objClass = Object.prototype.toString.call(obj).slice(8, -1);
            if(objClass === 'Object' || objClass === 'Array') {
                for(var key in obj) {
                    if(!obj.hasOwnProperty(key)) continue;
                    bytes += this.objsize(key);
                    bytes += this.objsize(obj[key]);
                }
            } else bytes += obj.toString().length;
            break;
        }
    }

    return bytes;
  }
};
