/*

Copyright (C) 2016 Freshdesk, Inc.

This source code is a part of the Freshdesk SDK and is covered by the our license
terms. For details about this license, please read the LICENSE.txt which is
bundled with this source code.

*/
'use strict';

const debuglog = __debug.bind(null, __filename);

var validationConst = require('./constants').validationContants;
var fileUtil = require('../utils/file-util');
var validFileNames = ['iparams.html', 'iparams.json', 'iparam_test_data.json', 'oauth_config.json'];

module.exports = {
  validate: function() {
    var errMsgs = [];
    var configFolderPath = process.cwd() + '/config/';
    if (fileUtil.fileExists(configFolderPath)) {
      var configFiles = fileUtil.readDir(configFolderPath);
      configFiles = configFiles.filter(fileUtil.removeJunkFiles);
      var invalidConfigFiles = [];
      for (var file of configFiles) {
        if (validFileNames.indexOf(file) < 0 ) {
          invalidConfigFiles.push(file);
        }
      }
      if (invalidConfigFiles.length > 0) {
        errMsgs.push(`Config directory has invalid file(s) - ${invalidConfigFiles}`);
      }
    }
    return errMsgs;
  },

  validationType: [validationConst.PRE_PKG_VALIDATION, validationConst.RUN_VALIDATION]
};
