/*

Copyright (C) 2016 Freshdesk, Inc.

This source code is a part of the Freshdesk SDK and is covered by the our license
terms. For details about this license, please read the LICENSE.txt which is
bundled with this source code.

*/
'use strict';

const debuglog = __debug.bind(null, __filename);

var nsUtil = require('../utils/ns-resolver');
var validationConst = require('./constants').validationContants;
var fileUtil = require('../utils/file-util');

var MAX_PKG_SIZE = 5000000;

module.exports = {
  validate: function() {
    var errMsgs = [];
    var plgDir = process.cwd() + `/dist/${nsUtil.getRootFolder()}${nsUtil.pkgExt}`;
    var fileStat = fileUtil.statFile(plgDir);
    if (fileStat.size > MAX_PKG_SIZE) {
      debuglog(`File size ${fileStat.size} for file ${plgDir}`)
      errMsgs.push("Package size exceeds the 5MB limit.");
    }
    return errMsgs;
  },

  validationType: [validationConst.POST_PKG_VALIDATION]
};