const eventListTimeout = 3000;

var ajaxRequest = function(options, callback) {
  jQuery.ajax(options)
  .done(function(data, textStatus, xhr) {
    callback(null, data, xhr);
  })
  .fail(function(xhr, error) {
    callback(error, null, xhr);
  })
}

var displayPayload = function(event) {
  jQuery("#editor-btns").show();
  var url = "http://localhost:10001/web/events/" + event;
  jQuery.get(url, function(data) {
    editor.model.setValue(JSON.stringify(data, null, 2))
  });
}

jQuery("#event-sel").on('click', function(e) {
  if (jQuery('#event-dropdown li').length == 0) {
    ajaxRequest({
      url: 'http://localhost:10001/web/eventsList',
      method: "GET",
      timeout: eventListTimeout,
      headers:{ "Content-Type" : "application/json" },
    }, function(err, data) {
      if (err) {
        jQuery("#event-area").html('<i class="fa" aria-hidden="true" style="color:red;">Error while fetching the events. Please refresh the page and try again.</i>');
        return;
      }
      var eventHtml = '';
      data.events.forEach(function(event) {
        eventHtml += '<li><a href="#">' + event + '</a></li>';
      });
      jQuery('#event-dropdown').append(eventHtml);
    });
  }
});

jQuery("#event-dropdown").on("click", function(e) {
  var event = e.target.text;
  jQuery("#event-sel").text(event);
  if (typeof editor == "undefined") {
    require.config({ paths: { 'vs': 'http://dl.freshdev.io/sdk-packages/monaco-editor/0.8.3/min/vs' }});
    require(['vs/editor/editor.main'], function() {
      window.editor = monaco.editor.create(document.getElementById('monaco-container'), {
        language: 'json',
        fontSize: 12
      });
      editor.getModel().updateOptions({ tabSize: 2})
      jQuery(".box").css("height","780px")
      displayPayload(event);
    });
  }
  else {
    displayPayload(event);
  }
});

jQuery("#simulate-event").on("click", function() {
  jQuery("#simulate-event").attr("disabled", true);
  var event = jQuery("#event-sel").text();
  ajaxRequest({
    method: "POST",
    headers:{ "Content-Type" : "application/json" },
    url: "http://localhost:10001/web/events/" + event,
    data: editor.model.getValue()
  }, function(err, data) {
    if (!err) {
      ajaxRequest({
        method: "POST",
        url: "http://localhost:10001/event/execute?name=" + event
      }, function(err, data, xhr) {
        if (err) {
          if (xhr.getResponseHeader('showinui') === 'true') {
            jQuery("#simulate-event").html('<i class="fa fa-times" aria-hidden="true" style="color:red;"></i> ' + xhr.responseJSON.message);
          }
          else {
            jQuery("#simulate-event").html('<i class="fa fa-times" aria-hidden="true" style="color:red;"></i> Failed');
          }
        }
        else {
          jQuery("#simulate-event").html('<i class="fa fa-check" aria-hidden="true" style="color:green;"></i> Success');
        }
        
        setTimeout(function() {
          jQuery("#simulate-event").html('Simulate');
          jQuery("#simulate-event").attr("disabled", false);
        }, 2000)
      })
    }
  })
});

jQuery("#reset-event").on("click", function() {
  var event = jQuery("#event-sel").text();
  jQuery.ajax({
    method: "POST",
    url: "http://localhost:10001/web/events/reset/" + event
  })
  .done(function(data) {
    editor.model.setValue(JSON.stringify(data, null, 2));
  })
});


jQuery.ajax({
    url: "http://localhost:10001/iframe/api",
    method: "get"
})
.done(function(data) {
  if (data.features.indexOf('oauth') != -1) {
    jQuery.ajax({
        url: "http://localhost:10001/accesstoken",
        method: "get"
    })
    .fail(function() {
      jQuery("#event-area").addClass("area-disable");
      jQuery("#info-banner").html("This app uses OAuth. <a href='http://localhost:10001/auth/index?callback=http://localhost:10001/web/events'>Click here to authorize.</a>")
    })
  }
})
