var tmp = require('tmp');
var request = require('supertest');
var fs = require('fs-extra');
var expect = require('chai').expect;

describe('ack test', function () {
  var projDir, server;

  before( function() {
    projDir = tmp.dirSync({prefix: 'freshapps_sdk'});
    require(__dirname + '/../lib/cli/init').run(projDir['name'], 'your_first_serverless_app');
    process.chdir(projDir['name']);
    var testServerFile = __dirname + '/../test-res/backend_excess_dep.js';
    var serverFile = projDir['name'] + '/server/server.js';
    var srcManifestFile = __dirname + '/../test-res/manifest/manifest_excess_dep.json';
    var manifestFile = projDir['name'] + '/manifest.json';
    fs.copySync(srcManifestFile, manifestFile);
    require(__dirname + '/../lib/manifest').reload();
    fs.copySync(testServerFile, serverFile);
    delete require.cache;
    fs.writeFileSync(projDir['name'] + '/.report.json', JSON.stringify({}));
  });

  it('catch unlisted and unused dependencies in manifest', function testSlash(done) {
    expect(require('../lib/validations/lint-validation.js').validate()[0]).eql([
      'The following dependencies are not used: needle',
      'The following dependencies are not listed in the manifest: request'
    ]);
    done();
  });
});
