var tmp = require('tmp');
var request = require('supertest');
var fs = require('fs-extra');

describe('BE-events test', function () {
  var projDir, server;

  before( function() {
    projDir = tmp.dirSync({prefix: 'freshapps_sdk'});
    require(__dirname + '/../lib/cli/init').run(projDir['name'], 'your_first_serverless_app');
    process.chdir(projDir['name']);
    var testServerFile = __dirname + '/../test-res/backend_server.js';
    var serverFile = projDir['name'] + '/server/server.js';
    require(__dirname + '/../lib/manifest').reload();
    fs.copySync(testServerFile, serverFile);
    delete require.cache;
    fs.writeFileSync(projDir['name'] + '/.report.json', JSON.stringify({}));
    server = require('../lib/cli/run').run();
  });

  after(function () {
    server.close();
  });

  it('should succeed - call backend event(onTicketCreate)', function testSlash(done) {
    request(server)
      .post('/event/execute?name=onTicketCreate')
      .send()
      .expect(200,done)
  })

  it('should fail - invalid event', function testSlash(done) {
    request(server)
      .post('/event/execute?name=abcdefghi')
      .send()
      .expect(400,done)
  })
});
