var expect = require('chai').expect;
var tmp = require('tmp');
var fs = require('fs-extra');

describe('Bknd event tests', function() {

  var projDir, eventValidator;

  before(function() {
    projDir = tmp.dirSync({prefix: 'freshapps_sdk'});
    require(__dirname + '/../lib/cli/init').run(projDir['name'], 'your_first_serverless_app');
    process.chdir(projDir['name']);
    require(__dirname + '/../lib/manifest').reload();
    eventValidator = require('../lib/validations/event-validation');
  });

  it("should validate bknd events", function(done) {
    expect([]).eql(eventValidator.validate());
    done();
  });

  it("should fail", function(done) {
    var invalidServerEventFile = __dirname + '/../test-res/server_invalid_event.js';
    var serverFile = projDir['name'] + '/server/server.js';
    fs.copySync(invalidServerEventFile, serverFile);
    expect(eventValidator.validate()).eql(['Invalid event: \'testEvent\'']);
    done();
  })
});