/*

Copyright (C) 2016 Freshdesk, Inc.

This source code is a part of the Freshdesk SDK and is covered by the our license
terms. For details about this license, please read the LICENSE.txt which is
bundled with this source code.

*/

var tmp = require('tmp');
var expect = require('chai').expect;

describe('Name space resolver test', function(){

  var projDir;

  before(function(){
    projDir = tmp.dirSync({prefix: 'freshapps_sdk'});
    require(__dirname + '/../lib/cli/init').run(projDir['name'], 'your_first_app');
    process.chdir(projDir['name']);
    require(__dirname + '/../lib/manifest').reload();
  });

  it('should get app_id', function(done) {
    var ns = require(__dirname + '/../lib/utils/ns-resolver');
    expect('{"app_id":"fresha_101_101"}').eql(JSON.stringify(ns.getNamespace()));
    done();
  });
});
