var tmp = require('tmp');
var fs = require('fs-extra');
var request = require('supertest');

describe('SMI Test', function() {
  var server, projDir;
  var payload, headers;

  before(function() {
    projDir = tmp.dirSync({prefix: 'freshapps_sdk'});
    require(__dirname + '/../lib/cli/init').run(projDir['name'], 'your_first_serverless_app');
    process.chdir(projDir['name']);
    require(__dirname + '/../lib/manifest').reload();
    payload = {
      methodName: 'callRemote',
      methodParams: { url: 'https://www.google.co.in' },
      action: 'invoke'
    };
    headers = {
      'content-type': 'application/json',
      'MKP-EXTNID': '101',
      'MKP-VERSIONID': '101',
      'MKP-ROUTE': 'smi'
    };
    delete require.cache;
  });

  afterEach(function() {
    server.close();
  });

  it ('should invoke the function in the server script', function(done) {
    var destFile = `${projDir['name']}/server/server.js`;
    var srcFile = `${__dirname}/../test-res/backend_server.js`;
    fs.copySync(srcFile, destFile);
    server = require(__dirname + '/../lib/cli/run').run();
    request(server)
      .post('/dprouter')
      .send(payload)
      .set(headers)
      .expect(200, done);
  });

})